/*
    -- clMAGMA (version 1.2.0) --
       Univ. of Tennessee, Knoxville
       Univ. of California, Berkeley
       Univ. of Colorado, Denver
       @date September 2014
*/

#ifndef MAGMA_AUXILIARY_H
#define MAGMA_AUXILIARY_H

#include "magma_types.h"

#ifdef __cplusplus
extern "C" {
#endif

magma_int_t magma_get_spotrf_nb(magma_int_t m);
magma_int_t magma_get_sgeqrf_nb(magma_int_t m);
magma_int_t magma_get_sgeqlf_nb(magma_int_t m);
magma_int_t magma_get_sgetrf_nb(magma_int_t m);
magma_int_t magma_get_sgetri_nb(magma_int_t m);
magma_int_t magma_get_sgehrd_nb(magma_int_t m);
magma_int_t magma_get_ssytrd_nb(magma_int_t m);
magma_int_t magma_get_sgelqf_nb(magma_int_t m);
magma_int_t magma_get_sgebrd_nb(magma_int_t m);
magma_int_t magma_get_ssygst_nb(magma_int_t m);
magma_int_t magma_get_sgesvd_nb(magma_int_t m);

magma_int_t magma_get_dpotrf_nb(magma_int_t m);
magma_int_t magma_get_dgeqrf_nb(magma_int_t m);
magma_int_t magma_get_dgeqlf_nb(magma_int_t m);
magma_int_t magma_get_dgetrf_nb(magma_int_t m);
magma_int_t magma_get_dgetri_nb(magma_int_t m);
magma_int_t magma_get_dgehrd_nb(magma_int_t m);
magma_int_t magma_get_dsytrd_nb(magma_int_t m);
magma_int_t magma_get_dgelqf_nb(magma_int_t m);
magma_int_t magma_get_dgebrd_nb(magma_int_t m);
magma_int_t magma_get_dsygst_nb(magma_int_t m);
magma_int_t magma_get_dgesvd_nb(magma_int_t m);

magma_int_t magma_get_cpotrf_nb(magma_int_t m);
magma_int_t magma_get_cgetrf_nb(magma_int_t m);
magma_int_t magma_get_cgetri_nb(magma_int_t m);
magma_int_t magma_get_cgeqrf_nb(magma_int_t m);
magma_int_t magma_get_cgeqlf_nb(magma_int_t m);
magma_int_t magma_get_cgehrd_nb(magma_int_t m);
magma_int_t magma_get_chetrd_nb(magma_int_t m);
magma_int_t magma_get_cgelqf_nb(magma_int_t m);
magma_int_t magma_get_cgebrd_nb(magma_int_t m);
magma_int_t magma_get_chegst_nb(magma_int_t m);
magma_int_t magma_get_cgesvd_nb(magma_int_t m);

magma_int_t magma_get_zpotrf_nb(magma_int_t m);
magma_int_t magma_get_zgetrf_nb(magma_int_t m);
magma_int_t magma_get_zgetri_nb(magma_int_t m);
magma_int_t magma_get_zgeqrf_nb(magma_int_t m);
magma_int_t magma_get_zgeqlf_nb(magma_int_t m);
magma_int_t magma_get_zgehrd_nb(magma_int_t m);
magma_int_t magma_get_zhetrd_nb(magma_int_t m);
magma_int_t magma_get_zgelqf_nb(magma_int_t m);
magma_int_t magma_get_zgebrd_nb(magma_int_t m);
magma_int_t magma_get_zhegst_nb(magma_int_t m);
magma_int_t magma_get_zgesvd_nb(magma_int_t m);

magma_int_t magma_get_smlsize_divideconquer();

void printout_devices();

void swp2pswp   (magma_trans_t trans, magma_int_t n, magma_int_t *ipiv, magma_int_t *newipiv);

double magma_wtime( void );
double magma_sync_wtime( magma_queue_t queue );


#ifdef __cplusplus
}
#endif

#endif  // MAGMA_AUXILIARY_H
