/*
 *   -- micMAGMA (version 1.2.0) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      @date September 2014
 *
 *   @author Azzam Haidar
 *   @author Khairul Kabir
 *
 *   @generated from magma_z_bindings.h normal z -> s, Wed Sep 17 15:37:45 2014
 */

#ifndef MAGMA_S_BINDINGS
#define MAGMA_S_BINDINGS
typedef struct {
    magma_int_t n;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    magmaFloat_const_ptr y;
    magma_int_t incy;
} magma_mic_scopy_param;

typedef struct {
    magma_trans_t transa;
    magma_trans_t transb;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
} magma_mic_sgemm_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_ssymm_param;

typedef struct {
    magma_trans_t transa;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    float beta;
    magmaFloat_const_ptr y;
    magma_int_t incy;
} magma_mic_sgemv_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    float beta;
    magmaFloat_const_ptr y;
    magma_int_t incy;
} magma_mic_ssymv_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr x;
    magma_int_t incx;
    float beta;
    magmaFloat_const_ptr y;
    magma_int_t incy;
} magma_mic_ssymv2_param;



typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
} magma_mic_ssyrk_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_ssyrk_mmic_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_ssyr2k_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
    magma_int_t boff;
    float beta;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_ssyr2k_mmic_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
} magma_mic_strsm_param;

typedef struct {
    magma_mic_strsm_param trsm_param;
    magma_mic_sgemm_param gemm_param;
} magma_mic_strsmgemm_param;

typedef struct {
  magma_uplo_t uplo;
  magma_trans_t trans;
  magma_diag_t diag;
  magma_int_t n;
  float alpha;
  magmaFloat_const_ptr a;
  magma_int_t lda;
  magmaFloat_const_ptr dx;
  magma_int_t incx;
} magma_mic_strsv_param;

typedef struct {
  magma_uplo_t  uplo;
  magma_trans_t trans;
  magma_diag_t  diag;
  magma_int_t n;
  float alpha;
  magmaFloat_const_ptr a;
  magma_int_t lda;
  magmaFloat_const_ptr dx;
  magma_int_t incx;
} magma_mic_strmv_param;
 
typedef struct {
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t n;
    magma_int_t k;
    magmaFloat_const_ptr v;
    magma_int_t ldv;
    magmaFloat_const_ptr tau;
    magmaFloat_const_ptr t;
    magma_int_t ldt;
} magma_mic_slarft_param;


typedef struct {
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaFloat_const_ptr v;
    magma_int_t ldv;
    magmaFloat_const_ptr t;
    magma_int_t ldt;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magmaFloat_const_ptr work;
    magma_int_t ldwork;
} magma_mic_slarfb_param;

typedef struct {
    magma_side_t   side;
    magma_trans_t  trans;
    magma_direct_t direct;
    magma_storev_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaFloat_const_ptr v;
    magma_int_t ldv;
    magmaFloat_const_ptr t;
    magma_int_t ldt;
    magmaFloat_const_ptr c;
    magma_int_t ldc;
    magmaFloat_const_ptr work;
    magma_int_t ldwork;
    magmaFloat_const_ptr workvt;
    magma_int_t ldworkvt;
} magma_mic_slarfb_gemm_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    float beta;
    magmaFloat_const_ptr dA;
    magma_int_t lda;
} magma_mic_slaset_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    float alpha;
    magmaFloat_const_ptr a;
    magma_int_t lda;
    magmaFloat_const_ptr b;
    magma_int_t ldb;
} magma_mic_strmm_param;


typedef struct {
    magmaFloat_const_ptr odata;
    magma_int_t ldo;
    magmaFloat_const_ptr idata;
    magma_int_t ldi;
    magma_int_t m;
    magma_int_t n;
} magma_mic_stranspose_param;


/*
typedef struct {
    magmaFloat_const_ptr d_AT;
    magma_int_t lda;
    magma_int_t *d_ipiv;
    magma_int_t nb;
    magma_int_t ind;
} magma_mic_slaswp_param;
*/


typedef struct {
    magma_int_t n;
    magmaFloat_const_ptr d_A;
    magma_int_t lda;
    magma_int_t k1;
    magma_int_t k2;
    magma_int_t *d_ipiv;
    magma_int_t incx;
} magma_mic_slaswp_param;


typedef struct {
    magma_int_t n;
    float *dA1T;
    magma_int_t lda1;
    float *dA2T;
    magma_int_t lda2;
} magma_mic_sswap_param;

#endif  // MAGMA_S_BINDINGS
